' Simple Cookie Manager Script
'
' Manage any "unclassified" browser cookies. "Good" cookies are
' copied to a Save folder, "bad" ones are deleted.  If/when a
' "good" cookie expires and is deleted by the browser, the Save
' copy is deleted as well.
'
' Cookie path = \Windows\Cookies
' Save path   = \Windows\Cookies\Save

Option Explicit
Dim fso, CFold, SFold, Cookies, f, fc, fs, fn, domain
Dim WindowsFolder, cntc, cntd, cnte, cncl
WindowsFolder = 0

Set fso = WScript.CreateObject("Scripting.FileSystemObject")
CFold = fso.GetSpecialFolder(WindowsFolder)
CFold = CFold & "\Cookies"
SFold = CFold & "\Save"

if Not fso.FolderExists(CFold) then WScript.Quit
if Not fso.FolderExists(SFold) then fso.CreateFolder(SFold)

Set fc = fso.GetFolder(CFold)
Set Cookies = fc.files
cntd = 0
cntc = 0
cnte = 0
cncl = 0

On Error Resume Next

MsgBox "This script will display each Internet Explorer " &_
  "cookie found on your system and ask whether " &_
  "it is a " & chr(34) & "good" & chr (34) & " cookie. " &_
  "If you answer yes, it will make a copy " &_
  "of the cookie as a reminder not to ask again. If you " &_
  "answer no, it will delete the cookie. You can cancel " &_
  "the process at any time and resume later." & chr(13) &_
  chr(10) & chr(13) & chr(10) & "The first time you run " &_
  "this script, it may take quite a while. After that, " &_
  "you should run it every few days.",_
  vbOKOnly + vbInformation, "Cookie Manager Script"

'--- Delete/Copy new cookies

For each fs in Cookies
Dim BoxResult 'njr
   fn = SFold & "\" & fs.name
   if Not fso.FileExists(fn) then  'cookie not yet classified
      Set f = fs.OpenAsTextStream(1,0)
      f.ReadLine
      f.ReadLine
      domain = f.ReadLine ' third line is domain
      f.Close
      BoxResult = MsgBox(fs.name & " from www." & domain &_
         ". Last Modified: " & fs.DateLastModified,_
         vbYesNoCancel + vbInformation,_
         "Is this a 'good' cookie ?" )
      Select Case BoxResult
        Case vbYes
          fs.Copy fn,True
          cntc = cntc + 1
        Case vbNo
          cntd = cntd + 1
          fs.Delete
        Case Else
          cncl = 1
          Exit For
      end Select
   end if
next

'--- Remove any "old" expired cookies

Set fc = fso.GetFolder(SFold)
Set Cookies = fc.files
For each fs in Cookies
   fn = CFold & "\" & fs.name
   if Not fso.FileExists(fn) then
      cnte = cnte + 1
      fs.Delete
   end if
next

'--- Display action summary

if (cntc=0) AND (cntd=0) AND (cnte=0) then
  if cncl=0 then  
    WScript.Echo("No new or expired cookies found.")
  else
    WScript.Echo("No new or expired cookies found before "&_
      "processing was cancelled by user.")
  end if
else
  if cncl=0 then
    wScript.Echo(cntd & " bad cookies deleted, " & cntc &_
      " good cookies copied, " & cnte & " expired cookie "&_
      "copies deleted.")
  else
    wScript.Echo(cntd & " bad cookies deleted, " & cntc &_
      " good cookies copied, " & cnte & " expired cookie " &_
      "copies deleted before processing was cancelled by user.")
  end if
end if

